/*
 * Copyright (C) 2012-2013 Daniel Medina <http://danielme.com>
 * 
 * This file is part of "Muspy for Android".
 * 
 * "Muspy for Android" is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * "Muspy for Android" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License version 3
 * along with this program.  If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>
 */
package com.danielme.muspyforandroid.homescreenwidget;

import com.danielme.muspyforandroid.Constants;

import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.Context;
import android.content.Intent;


/**
 * 
 * @author Daniel Medina (danielme.com)
 * @since 1.1
 *
 */
public class WidgetProvider extends AppWidgetProvider
{
	
	@Override
	public void onReceive(Context context, Intent intent) 
	{ 
	    if (intent.getAction().equals(Constants.INTENT_WIDGET)) 
	    {
	        int widgetId = intent.getIntExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, AppWidgetManager.INVALID_APPWIDGET_ID);

	        AppWidgetManager appWidgetManager = AppWidgetManager.getInstance(context);	        
	      
	        if (widgetId != AppWidgetManager.INVALID_APPWIDGET_ID)
	        {	        	   
	           actualizarWidget(context, appWidgetManager, widgetId);
	        }
	    }
	    super.onReceive(context, intent);
	}
	
	@Override
	public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds)
	{ 	
		for (int i = 0; i < appWidgetIds.length; i++) 
		{
			actualizarWidget(context, appWidgetManager, appWidgetIds[i]);
		}
	}

	private void actualizarWidget(Context context, AppWidgetManager appWidgetManager, int appWidgetId)
	{	
		Intent intent = new Intent(context.getApplicationContext(), WidgetIntentService.class);
		 intent.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, appWidgetId);

		 context.startService(intent);
	}
}
